import { TokenAmount } from './entities/fractions/tokenAmount';
import { Price } from './entities/fractions/price';
import { Message } from './entities/eip712';
import { ChainId } from './constants';
import { ethers } from 'ethers';
export declare class LimitOrder {
    readonly maker: string;
    readonly amountIn: TokenAmount;
    readonly amountOut: TokenAmount;
    readonly recipient: string;
    readonly startTime: string;
    readonly endTime: string;
    readonly stopPrice: string;
    readonly oracleAddress: string;
    readonly oracleData: string;
    v: number;
    r: string;
    s: string;
    constructor(maker: string, amountIn: TokenAmount, amountOut: TokenAmount, recipient: string, startTime: string, endTime: string, stopPrice: string, oracleAddress: string, oracleData: string);
    usePrice(price: Price): LimitOrder;
    signdOrderWithPrivatekey(chainId: ChainId, privateKey: string): {
        v: number;
        r: string;
        s: string;
    };
    signOrderWithProvider(chainId: ChainId, provider: ethers.providers.Web3Provider): Promise<{
        v: number;
        r: string;
        s: string;
    }>;
    getTypedData(chainId: ChainId): {
        types: {
            EIP712Domain: {
                name: string;
                type: string;
            }[];
            LimitOrder: {
                name: string;
                type: string;
            }[];
        };
        primaryType: string;
        domain: import("./entities/eip712").Domain;
        message: Message;
    };
}
