import JSBI from 'jsbi'

import { SolidityType } from '../constants'
import { validateSolidityTypeInstance } from '../utils'

export class Currency {
    public readonly decimals: number
    public readonly symbol?: string
    public readonly name?: string
  public static readonly ETHER: Currency = new Currency(18, 'ETH', 'Ether')
    /**
     * Constructs an instance of the base class `Currency`. The only instance of the base class `Currency` is `Currency.ETHER`.
     * @param decimals decimals of the currency
     * @param symbol symbol of the currency
     * @param name of the currency
     */
  protected constructor(decimals: number/* , address: string */, symbol?: string, name?: string) {
      validateSolidityTypeInstance(JSBI.BigInt(decimals), SolidityType.uint8)
  
      this.decimals = decimals
      this.symbol = symbol
      this.name = name
      // this.address = validateAndParseAddress(address)
    }
}
const ETHER = Currency.ETHER
export { ETHER }